﻿#include "WizCertManager.h"

#if 0

#include "share/WizDatabaseManager.h"

WizCertManager::WizCertManager(WizExplorerApp& app, const QString& strAccountsApiURL /* = WIZ_API_URL*/)
    : CWizApiBase(strAccountsApiURL)
    , m_app(app)
    , m_db(app.databaseManager().db())
    , m_bCertInited(false)
{
}

void WizCertManager::onXmlRpcError(const QString& strMethodName, \
                                    WizXmlRpcError err, \
                                    int errorCode, \
                                    const QString& errorMessage)
{
    Q_UNUSED(strMethodName);
    Q_UNUSED(err);
    Q_UNUSED(errorCode);
    Q_UNUSED(errorMessage);

    Q_EMIT done(false, errorMessage);
}

void WizCertManager::onGetUserCert(const WIZUSERCERT& data)
{
    // save to database
    if(!m_db.setUserCert(data.strN, \
                         data.stre, \
                         data.strd, \
                         data.strHint)) {

        TOLOG("update user cert failed");
        return;
    }

    m_bCertInited = true;
    Q_EMIT done(true, QString());
}

void WizCertManager::loadUserCert()
{
    if (m_bCertInited) {
        Q_EMIT done(true, QString());
        return;
    }

    bool ret = m_db.getUserCert(m_cert.strN, m_cert.stre, m_cert.strd, m_cert.strHint);

    if (!ret) {
        downloadUserCert();
    } else {
        m_bCertInited = true;
        Q_EMIT done(true, QString());
    }
}

bool WizCertManager::downloadUserCert()
{
    return callGetUserCert(m_db.getUserId(), m_db.getPassword());
}

#endif // 0
